//%attributes = {}
ARRAY TEXT:C222($TeventKeys_R; 0)
C_DATE:C307($Date; $FirstDate)
C_LONGINT:C283($i; $j; $Loffset; $LcalendarID; $Lerror)
C_LONGINT:C283($POSIXtime)
C_LONGINT:C283($Ltime)

Compiler_D_P
Compiler_S_P


$FirstDate:=!2100-01-01!

//Selection of all ics
QUERY BY FORMULA:C48([Member:1]; BLOB size:C605([Member:1]iCal:5)#0)

While (Not:C34(End selection:C36([Member:1])))
	$LcalendarID:=CS_CreateCalendar
	APPEND TO ARRAY:C911(D_LiCalID_R; $LcalendarID)
	APPEND TO ARRAY:C911(D_LiCalMember_R; [Member:1]memberID:1)
	CS_SetCalendarTextProperty($LcalendarID; CS_iCal_Name; [Member:1]name:2)
	CS_SetCalendarTextProperty($LcalendarID; CS_iCal_Description; "Calendar of "+[Member:1]name:2)
	CS_SetCalendarLongProperty($LcalendarID; CS_iCal_Visible; Num:C11([Member:1]active:8))
	CS_SetCalendarLongProperty($LcalendarID; CS_iCal_ReadOnly; 0)
	
	$Lerror:=CS_ParseEvent($LcalendarID; BLOB to text:C555([Member:1]iCal:5; UTF8 texte sans longueur:K22:17))
	
	If ($Lerror#0)
		ALERT:C41("ERROR: "+String:C10($Lerror))
	Else 
		$Lerror:=CS_GetObjects($LcalendarID; CS_Objects_iCal_Events; $TeventKeys_R)
		
		For ($i; 1; Size of array:C274($TeventKeys_R))
			$Date:=CS_GetEventDateProperty($LcalendarID; $TeventKeys_R{$i}; CS_Event_StartDateAdj)
			If ($Date<$FirstDate)
				$FirstDate:=$Date
			End if 
		End for 
		
	End if 
	
	NEXT RECORD:C51([Member:1])
End while 


//Apply the style to each save event
$j:=Year of:C25(Current date:C33)-Year of:C25($FirstDate)
$i:=F_WeekNumber(Current date:C33)-F_WeekNumber($FirstDate)
$Loffset:=(($j*52)+$i)*7  //offset in days


If ($Loffset>0)
	READ WRITE:C146([Member:1])
	
	For ($i; 1; Size of array:C274(D_LiCalID_R))
		$Lerror:=CS_GetObjects(D_LiCalID_R{$i}; CS_Objects_iCal_Events; $TeventKeys_R)
		
		For ($j; 1; Size of array:C274($TeventKeys_R))
			$Date:=CS_GetEventDateProperty(D_LiCalID_R{$i}; $TeventKeys_R{$j}; CS_Event_EndDate)
			$Date:=Add to date:C393($Date; 0; 0; $Loffset)
			CS_SetEventDateProperty(D_LiCalID_R{$i}; $TeventKeys_R{$j}; CS_Event_EndDate; $Date)
			
			$Date:=CS_GetEventDateProperty(D_LiCalID_R{$i}; $TeventKeys_R{$j}; CS_Event_StartDate)
			$Date:=Add to date:C393($Date; 0; 0; $Loffset)
			CS_SetEventDateProperty(D_LiCalID_R{$i}; $TeventKeys_R{$j}; CS_Event_StartDate; $Date)
			
			
			$POSIXtime:=CS_GetEventLongProperty(D_LiCalID_R{$i}; $TeventKeys_R{$j}; CS_Event_RecurrEnd)
			If ($POSIXtime>0)
				CS_PosixTimeToDateTime($POSIXtime; $Date; $Ltime)
				$Date:=Add to date:C393($Date; 0; 0; $Loffset)
				$POSIXtime:=CS_DateTimeToPosixTime($Date; $Ltime)
				CS_SetEventLongProperty(D_LiCalID_R{$i}; $TeventKeys_R{$j}; CS_Event_RecurrEnd; $POSIXtime)
			End if 
			
		End for 
		
		
		QUERY:C277([Member:1]; [Member:1]memberID:1=D_LiCalMember_R{$i})
		TEXT TO BLOB:C554(CS_GetCalendarTextProperty(D_LiCalID_R{$i}; CS_iCal_VCAL); [Member:1]iCal:5; UTF8 texte sans longueur:K22:17)
		SAVE RECORD:C53([Member:1])
		CS_DeleteCalendar(D_LiCalID_R{$i})
	End for 
	
End if 