//%attributes = {}
// E_ModifyEB

C_BOOLEAN:C305($1)
C_BOOLEAN:C305($2; $Banner)

C_LONGINT:C283($LiCalID; $Lref; $POSIXtime; $Ltime)
C_TEXT:C284($TeventKey; $TeventUID)

Compiler_E_P
LIST TO ARRAY:C288("itemTypes"; E_TitemType_R)
LIST TO ARRAY:C288("itemLocked"; E_TitemLocked_R)
LIST TO ARRAY:C288("itemStatus"; E_TitemStatus_R)
LIST TO ARRAY:C288("itemRecFreq"; E_TitemRecFreq_R)

COPY ARRAY:C226(S_TlistStyles_R; E_TlistStyles_R)
COPY ARRAY:C226(S_ListStyles_R; E_ListStyles_R)

If (Count parameters:C259>1)
	$Banner:=$2
End if 

If ($1)
	//Modify
	E_TentryType_V:="Modify"
	$TeventKey:=CS_GetAreaTextProperty(D_LiCal_X; CS_Area_ClickedEventID)  //Event or banner ID
	$LiCalID:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_iCal)
	$TeventUID:=CS_GetEventTextProperty(D_LiCal_X; $TeventKey; CS_Event_UID)
	D_TiCalName_R:=Find in array:C230(D_LiCalID_R; $LiCalID)
	//Select the good calendar in the LB
	LISTBOX SELECT ROW:C912(D_BlistBox_R; D_TiCalName_R)
	E_Banner_V:=(CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_AllDay)=1)
	E_TitemType_R:=Choose:C955(E_Banner_V; 2; 1)
	E_Title_V:=CS_GetEventTextProperty(D_LiCal_X; $TeventKey; CS_Event_Summary)
	E_Tdescription_V:=CS_GetEventTextProperty(D_LiCal_X; $TeventKey; CS_Event_Description)
	E_DstartDate_V:=CS_GetEventDateProperty(D_LiCal_X; $TeventKey; CS_Event_StartDateAdj)
	E_HstartTime_V:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_StartTimeAdj)
	E_DendDate_V:=CS_GetEventDateProperty(D_LiCal_X; $TeventKey; CS_Event_EndDateAdj)
	E_HendTime_V:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_EndTimeAdj)
	E_TitemLocked_R:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_Locked)+1
	E_BitemNotLocked_R:=(E_TitemLocked_R<2)
	E_TitemStatus_R:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_Status)+1
	E_Tlocation_V:=CS_GetEventTextProperty(D_LiCal_X; $TeventKey; CS_Event_Location)
	
	//Recurrence
	E_TitemRecFreq_R:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_RecurrFrequency)+1
	If (E_TitemRecFreq_R>4)  //No second, no minute, no hour on Frequency
		E_TitemRecFreq_R:=E_TitemRecFreq_R-3
	End if 
	E_LrecInterval_V:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_RecurrInterval)
	E_LrecCount_V:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_RecurrCount)
	$POSIXtime:=CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Event_RecurrEnd)
	If ($POSIXtime>0)
		CS_PosixTimeToDateTime($POSIXtime; E_DateRecEnd_V; $Ltime)
		E_HtimeRecEnd_V:=$Ltime+0x0000
	Else 
		E_DateRecEnd_V:=!00-00-00!
		E_HtimeRecEnd_V:=?00:00:00?
	End if 
	
	//Styles
	E_TlistStyles_R:=Find in array:C230(E_ListStyles_R; CS_GetEventLongProperty(D_LiCal_X; $TeventKey; CS_Style_BaseStyleID))
Else 
	//Add
	E_TentryType_V:="Add"
	E_TitemType_R:=1
	
	//Calendar selection
	$LiCalID:=CS_GetAreaLongProperty(D_LiCal_X; CS_Area_DefaultForNewEvent)
	$Lref:=Find in array:C230(D_LiCalID_R; $LiCalID)
	If ($Lref>0)
		D_TiCalName_R:=$Lref
	Else 
		D_TiCalName_R:=1
	End if 
	E_Banner_V:=$Banner
	E_TitemType_R:=Choose:C955(E_Banner_V; 2; 1)
	E_Title_V:=""
	E_Tdescription_V:=""
	E_DstartDate_V:=D_DclickedDate_V
	E_HstartTime_V:=Time:C179((Current time:C178\3600)*3600)
	E_HendTime_V:=E_HstartTime_V+3600  //+ 1Hour
	
	If (E_HendTime_V>=?24:00:00?)
		E_DendDate_V:=Add to date:C393(E_DstartDate_V; 0; 0; 1)
		E_HendTime_V:=E_HendTime_V-?24:00:00?
	Else 
		E_DendDate_V:=E_DstartDate_V
	End if 
	E_TitemLocked_R:=1
	E_BitemNotLocked_R:=True:C214
	E_TitemStatus_R:=1
	E_Tlocation_V:=""
	
	////Recurrence
	E_TitemRecFreq_R:=1
	E_LrecInterval_V:=0
	E_LrecCount_V:=0
	E_DateRecEnd_V:=!00-00-00!
	E_HtimeRecEnd_V:=?00:00:00?
	
	//Styles
	E_TlistStyles_R:=0
End if 



F_CenterWindow(740; 450; 5; "Event/Banner Entry")
DIALOG:C40("E_EventBanner")
CLOSE WINDOW:C154

If (OK=1)
	If (E_TentryType_V="Add")
		$TeventKey:=CS_AddEvent(D_LiCalID_R{D_TiCalName_R}; E_Title_V; E_Tdescription_V; E_DstartDate_V)
		$Lref:=D_LiCalID_R{D_TiCalName_R}  //iCall
	Else   //Modify
		If (D_LiCalID_R{D_TiCalName_R}#$LiCalID)  //iCal as move of member 
			CS_MoveEvent($LiCalID; $TeventUID; D_LiCalID_R{D_TiCalName_R})
			$TeventKey:=$TeventUID
			$Lref:=D_LiCalID_R{D_TiCalName_R}  //iCall
		Else 
			$Lref:=D_LiCal_X
		End if 
	End if 
	
	//Apply all changes
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_AllDay; Num:C11(E_Banner_V))
	CS_SetEventTextProperty($Lref; $TeventKey; CS_Event_Summary; E_Title_V)
	CS_SetEventTextProperty($Lref; $TeventKey; CS_Event_Description; E_Tdescription_V)
	If (E_Banner_V & (E_DstartDate_V=E_DendDate_V))  //1 day min
		E_DendDate_V:=Add to date:C393(E_DendDate_V; 0; 0; 1)  //add 1 day
	End if 
	CS_SetEventDateProperty($Lref; $TeventKey; CS_Event_StartDateAdj; E_DstartDate_V)
	CS_SetEventDateProperty($Lref; $TeventKey; CS_Event_EndDateAdj; E_DendDate_V)
	If (Not:C34(E_Banner_V) & (E_HstartTime_V=E_HendTime_V) & (E_DstartDate_V=E_DendDate_V))  //15 min. min
		E_HendTime_V:=E_HendTime_V+(15*60)  //add 15 min to end time
	End if 
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_StartTimeAdj; E_HstartTime_V+0x0000)
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_EndTimeAdj; E_HendTime_V+0x0000)
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_Locked; E_TitemLocked_R-1)
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_Status; E_TitemStatus_R-1)
	CS_SetEventTextProperty($Lref; $TeventKey; CS_Event_Location; E_Tlocation_V)
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrFrequency; Choose:C955(E_TitemRecFreq_R>1; E_TitemRecFreq_R+2; E_TitemRecFreq_R-1))  //No second, no minute, no hour on Frequency
	If (E_TitemRecFreq_R>1)
		CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrInterval; E_LrecInterval_V)
		
		CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrCount; E_LrecCount_V)
		$Ltime:=E_HtimeRecEnd_V+0x0000
		$POSIXtime:=CS_DateTimeToPosixTime(E_DateRecEnd_V; $Ltime)
		CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrEnd; $POSIXtime)
	End if 
	
	
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Style_BaseStyleID; E_ListStyles_R{E_TlistStyles_R})
	
	If (D_TiCalName_R{D_TiCalName_R}="Birthdays")
		CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_Icon; 0x8000000B)
	Else 
		CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_Icon; 0)
	End if 
	
	If ((E_ListStyles_R{E_TlistStyles_R}#CS_Style_Event) & (E_ListStyles_R{E_TlistStyles_R}#CS_Style_Banner))  //Not the default style for banner and event
		QUERY:C277([iCalEventsStyle:2]; [iCalEventsStyle:2]eventKey:2=$TeventUID)
		If (Records in selection:C76([iCalEventsStyle:2])=0)
			CREATE RECORD:C68([iCalEventsStyle:2])
			[iCalEventsStyle:2]eventKey:2:=$TeventUID
		End if 
		[iCalEventsStyle:2]styleID:3:=E_ListStyles_R{E_TlistStyles_R}
		SAVE RECORD:C53([iCalEventsStyle:2])
	End if 
End if 
