//%attributes = {}
C_LONGINT:C283($1)
C_TEXT:C284($2)

C_LONGINT:C283($Lref; $Ltime; $LposixTime)
C_TEXT:C284($TeventKey; $TeventUID)
C_DATE:C307($DstartDate; $DendDate)
C_TIME:C306($HstartTime; $HendTime)

$DstartDate:=CS_GetEventDateProperty($1; $2; CS_Event_StartDate)
$DendDate:=CS_GetEventDateProperty($1; $2; CS_Event_EndDate)
$HstartTime:=CS_GetEventLongProperty($1; $2; CS_Event_StartTime)+?00:00:00?
$HendTime:=CS_GetEventLongProperty($1; $2; CS_Event_EndTime)+?00:00:00?

$TeventKey:=CS_AddEvent(D_LiCalID_R{D_TiCalName_R}; E_Title_V; E_Tdescription_V; E_DstartDate_V)
$Lref:=D_LiCalID_R{D_TiCalName_R}

CS_SetEventTextProperty($Lref; $TeventKey; CS_Event_Summary; E_Title_V)
CS_SetEventTextProperty($Lref; $TeventKey; CS_Event_Description; E_Tdescription_V)
CS_SetEventDateProperty($Lref; $TeventKey; CS_Event_StartDateAdj; E_DstartDate_V)
CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_StartTimeAdj; E_HstartTime_V+0x0000)
CS_SetEventDateProperty($Lref; $TeventKey; CS_Event_EndDateAdj; E_DendDate_V)
CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_EndTimeAdj; E_HendTime_V+0x0000)

CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_AllDay; Num:C11(E_Banner_V))

CS_SetEventLongProperty($Lref; $TeventKey; CS_Style_BaseStyleID; E_ListStyles_R{E_TlistStyles_R})

CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_Locked; E_TitemLocked_R-1)
CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_Status; E_TitemStatus_R-1)
CS_SetEventTextProperty($Lref; $TeventKey; CS_Event_Location; E_Tlocation_V)
If (E_TitemRecFreq_R>1)
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrFrequency; E_TitemRecFreq_R+2)  // //No second, no minute, no hour on Frequency
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrInterval; E_LrecInterval_V)
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrCount; E_LrecCount_V)
	$Ltime:=E_HtimeRecEnd_V+0x0000
	$LposixTime:=CS_DateTimeToPosixTime(E_DateRecEnd_V; $Ltime)
	CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_RecurrEnd; $LposixTime)
End if 

CS_SetEventLongProperty($Lref; $TeventKey; CS_Event_AllDay; Num:C11(E_Banner_V))

CS_SetEventLongProperty($Lref; $TeventKey; CS_Style_BaseStyleID; E_ListStyles_R{E_TlistStyles_R})

If ((E_ListStyles_R{E_TlistStyles_R}#CS_Style_Event) & (E_ListStyles_R{E_TlistStyles_R}#CS_Style_Banner))  //Not the default style for banner and event
	QUERY:C277([iCalEventsStyle:2]; [iCalEventsStyle:2]eventKey:2=$TeventUID)
	If (Records in selection:C76([iCalEventsStyle:2])=0)
		CREATE RECORD:C68([iCalEventsStyle:2])
		[iCalEventsStyle:2]eventKey:2:=$TeventUID
	End if 
	[iCalEventsStyle:2]styleID:3:=E_ListStyles_R{E_TlistStyles_R}
	SAVE RECORD:C53([iCalEventsStyle:2])
End if 


D_DclickedDate_V:=$DstartDate
